'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = stateFromHTML;

var _draftJsImportElement = require('draft-js-import-element');

var _parseHTML = require('./parseHTML');

var _parseHTML2 = _interopRequireDefault(_parseHTML);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function stateFromHTML(html, options) {
  var _ref = options || {},
      parser = _ref.parser,
      continueCodeBlock = _ref.continueCodeBlock,
      otherOptions = _objectWithoutProperties(_ref, ['parser', 'continueCodeBlock']);

  if (parser == null) {
    parser = _parseHTML2.default;
  }
  var element = parser(html);
  // hack for multiline block
  if (continueCodeBlock) {
    var preBlocks = element.querySelectorAll('pre');
    Array.prototype.forEach.call(preBlocks, function (node) {
      var lines = node.querySelectorAll('[data-line-num]');
      if (lines.length > 1) {
        var docFrag = document.createDocumentFragment();
        while (node.firstChild) {
          var wrapper = node.cloneNode();
          wrapper.innerHTML = '';
          var removed = node.removeChild(node.firstChild);
          wrapper.append(removed);
          docFrag.append(wrapper);
        }
        node.parentNode.replaceChild(docFrag, node);
      }
    });
  }

  return (0, _draftJsImportElement.stateFromElement)(element, otherOptions);
}